﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace example
{
    public partial class Form1 : Form
    {
        [DllImport("pstoimage", CallingConvention = CallingConvention.StdCall)]
        public static extern int MBegin();

        [DllImport("pstoimage", CallingConvention = CallingConvention.StdCall)]
        public static extern int MConvert(int id,string infile,string outpath,string filename);

        [DllImport("pstoimage", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSetParam(int id, int imagetype, int bitcount, int quality,int rotate,int width,int height,int xdpi,int ydpi,int compression,int multipage);

        [DllImport("pstoimage", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEnd(int id);

        const int IMAGE_FORMAT_BMP = 1; 
        const int IMAGE_FORMAT_EMF = 2; 
        const int IMAGE_FORMAT_WMF = 3; 
        const int IMAGE_FORMAT_JPG = 4; 
        const int IMAGE_FORMAT_PNG = 5; 
        const int IMAGE_FORMAT_GIF = 6; 
        const int IMAGE_FORMAT_TIF = 7;  
        const int IMAGE_FORMAT_PCX = 8; 
        const int IMAGE_FORMAT_TGA = 9;  
        const int IMAGE_FORMAT_JP2 = 10;
        const int IMAGE_FORMAT_RAS = 11;
        const int IMAGE_FORMAT_JPC = 12;
        /////////////////////////////////////////////////////////////////////////////
        //The compression method in the generated TIFF file.
        const int COMPRESSION_NONE		= 0; 
        const int COMPRESSION_LZW		= 1;
        const int COMPRESSION_JPEG		= 2;
        const int COMPRESSION_PACKBITS	= 3;
        const int COMPRESSION_CCITTG4	= 4;
        const int COMPRESSION_CCITTG3	= 5;
        const int COMPRESSION_RLE		= 6;

        /////////////////////////////////////////////////////////////////////////////
        const int BITCOUNT_1	= 1;	//black/white( 1 bits )
        const int BITCOUNT_4G	= 3;	//16 color grayscale( 4 bits )
        const int BITCOUNT_4	= 4;	//16 color( 4 bits )
        const int BITCOUNT_8G	= 7;	//256 color grayscale( 8 bits )
        const int BITCOUNT_8	= 8;	//256 color( 8 bits )
        const int BITCOUNT_24 = 24;	//True color( 24 bits )


        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int id = MBegin();    
            if(id>0)
            {
                int imagetype = IMAGE_FORMAT_TIF;
                int bitcount = BITCOUNT_24;
                int quality = 75;
                int rotate = 0;
                int width = 0;
                int height = 0;
                int xdpi = 150;
                int ydpi = 150;

                int compression = COMPRESSION_LZW;
                int multipage = 1;

                //Set Output image param
                MSetParam(id, imagetype, bitcount, quality, rotate, width, height, xdpi, ydpi, compression, multipage);

                //Convert to tiff file (multiple page)
                MConvert(id, "test.ps", "", "multiple");
                MEnd(id);
	        }	
	        MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int id = MBegin();
            if (id > 0)
            {
                int imagetype = IMAGE_FORMAT_JPG;
                int bitcount = BITCOUNT_8G;//256 color grayscale( 8 bits )
                int quality = 85;
                int rotate = 90;
                int width = 1000;
                int height = 800;
                int xdpi = 200;
                int ydpi = 200;
                //only for tiff
                int compression = 0;
                int multipage = 0;

                //Set Output image param
                MSetParam(id, imagetype, bitcount, quality, rotate, width, height, xdpi, ydpi, compression, multipage);

                //Convert to jpg file
                MConvert(id, "test.ps", "path", "jpg");

                MEnd(id);
            }
            MessageBox.Show("Convert finished!");
        }
    }
}
